// 26-03-15
expToJpg ();
function expToJpg () {

  var newDateFrame = (function redate () {
    var txtFrameDateName = '__current_date_and_time__',
        txtFrameDate,
        now              = new Date (),
        strDate          = 'Дата:\n' + _formatDate ( now ) + '\nВремя:\n' + _formatTime ( now ),
        lay              = activeDocument.activeLayer,
        artb             = ( activeDocument.artboards[ activeDocument.artboards.getActiveArtboardIndex() ] ).artboardRect,
        pos              = [ artb[ 0 ], artb[ 1 ] ];

    try {
      txtFrameDate = activeDocument.textFrames.getByName( txtFrameDateName );

      if ( txtFrameDate.contents != strDate ) {
        _setTxtAttributes ( txtFrameDate );
        txtFrameDate.contents = strDate;
      }
    } catch ( e ) {
// $.writeln( 'date/time frame error' );
      if ( +confirm ( 'Make new date frame on active layer?' ) ) {
        txtFrameDate = lay.textFrames.add();
        _setTxtAttributes ( txtFrameDate );
        txtFrameDate.contents = strDate;
        txtFrameDate.name = txtFrameDateName;
        txtFrameDate.position = pos;
        return true;
      }
    }

    function _setTxtAttributes ( txtFrame ) {
      txtFrameDate.textRange.characterAttributes.size = 11;
      txtFrameDate.textRange.paragraphAttributes.justification = Justification.CENTER;
    }

    function _formatTime ( date ) {

      var hh = date.getHours();
      if ( hh < 10 ) hh = '0' + hh;

      var mn = date.getMinutes();
      if ( mn < 10 ) mn = '0' + mn;

      return hh + ':' + mn;
    }

    function _formatDate ( date ) {

      var dd = date.getDate()
      if ( dd < 10 ) dd = '0' + dd;

      var mm = date.getMonth() + 1
      if ( mm < 10 ) mm = '0' + mm;

      var yy = date.getFullYear() % 100;
      if ( yy < 10 ) yy = '0' + yy;

      return dd + '.' + mm + '.' + yy;
    }
  } ());
  if ( newDateFrame ) {
    alert ( 'Start export again' );
    return;
  }

  /**============================>>
   * MAIN WINDOW *
   ==============================*/
  var mainWin = new Window ( 'dialog', 'Export to jpg' );
  mainWin.randStrArr = [];
  mainWin.count = 1;
  mainWin.suffix = '';
  mainWin.customDir = null;
  mainWin.appVer = +app.version.slice ( 0, 2 );
  mainWin.replaceYes = false;
  mainWin.dirNearFile = false;
  mainWin.help = (function () {
    return {
      str: 'Cкрипт экспорта слоев в формат .jpg.' + '\n' +
           'Среда выполнения скрипта: Adobe Illustrator CS3-CC.' + '\n' +
           'Язык скрипта: JavaScript.' + '\n\n\n' +
           '   ВОЗМОЖНОСТИ И ИСПОЛЬЗОВАНИЕ' + '\n\n' +
           '  -  Можно экспортировать несколько наборов слоев сразу.' + '\n\n' +
           '  -  Пока есть ограничение на кол-во джипегов, которые можно сделать за раз: от 1 до 4.' + '\n\n' +
           '  -  Цветовое пространство RGB.' + '\n\n' +
           '  -  Отдельные настройки качества изображения для каждого набора слоев.' + '\n\n' +
           '  -  Путь сохранения файлов: по-умолчанию папка "jpg", параллельная папке с ai-файлом;' + '\n\n' +
           '     можно указать или создать свою папку - кнопка "Change folder";' + '\n\n' +
           '     можно создать папку "jpg" рядом с ai-файлом - чекбокс "jpg-folder near ai-file".' + '\n\n' +
           '  -  Имя jpg-файлов состоит из имени ai-файла (любого, открытого в люстре файла) и приписки-суффикса.' + '\n\n' +
           '  -  Суффикс по-умолчанию - имя верхнего слоя из экспортируемого набора слоев.' + '\n\n' +
           '     можно выбрать "Ordinal num (Порядковый номер)" или "Random num (Случайное число)" или "Self (Своё)";' + '\n\n' +
           '     причем, если выбрать "Self", а поле ввода оставить пустым, то суффикс к имени файла не добавляется.' + '\n\n' +
           '  -  Запрашивать подтверждение на замену существующих jpg-файлов - чекбокс' + '\n\n' +
           '     "Confirmation to replace existing files"' + '\n\n\n' +
           '  -  Кнопки:' + '\n\n' +
           '      "OkGo!" - запустить экспорт' + '\n' +
           '      "OhNo!" - выйти из скрипта' + '\n\n\n' +
           'Предложения/пожелания' + '\n' +
           'mailto: marat_js@bk.ru'
    }
  }) ();
  mainWin.pngBtns = (function () {
    return {
      strGo:   '\x89\x50\x4e\x47\x0d\x0a\x1a\x0a\x00\x00\x00\x0d\x49\x48\x44\x52\x00\x00\x00\x38\x00\x00\x00\x10\x08\x06\x00\x00\x00\x43\x79\xbc\x45\x00\x00\x00\x19\x74\x45\x58\x74\x53\x6f\x66\x74\x77\x61\x72\x65\x00\x41\x64\x6f\x62\x65\x20\x49\x6d\x61\x67\x65\x52\x65\x61\x64\x79\x71\xc9\x65\x3c\x00\x00\x03\x66\x69\x54\x58\x74\x58\x4d\x4c\x3a\x63\x6f\x6d\x2e\x61\x64\x6f\x62\x65\x2e\x78\x6d\x70\x00\x00\x00\x00\x00\x3c\x3f\x78\x70\x61\x63\x6b\x65\x74\x20\x62\x65\x67\x69\x6e\x3d\x22\xef\xbb\xbf\x22\x20\x69\x64\x3d\x22\x57\x35\x4d\x30\x4d\x70\x43\x65\x68\x69\x48\x7a\x72\x65\x53\x7a\x4e\x54\x63\x7a\x6b\x63\x39\x64\x22\x3f\x3e\x20\x3c\x78\x3a\x78\x6d\x70\x6d\x65\x74\x61\x20\x78\x6d\x6c\x6e\x73\x3a\x78\x3d\x22\x61\x64\x6f\x62\x65\x3a\x6e\x73\x3a\x6d\x65\x74\x61\x2f\x22\x20\x78\x3a\x78\x6d\x70\x74\x6b\x3d\x22\x41\x64\x6f\x62\x65\x20\x58\x4d\x50\x20\x43\x6f\x72\x65\x20\x35\x2e\x33\x2d\x63\x30\x31\x31\x20\x36\x36\x2e\x31\x34\x35\x36\x36\x31\x2c\x20\x32\x30\x31\x32\x2f\x30\x32\x2f\x30\x36\x2d\x31\x34\x3a\x35\x36\x3a\x32\x37\x20\x20\x20\x20\x20\x20\x20\x20\x22\x3e\x20\x3c\x72\x64\x66\x3a\x52\x44\x46\x20\x78\x6d\x6c\x6e\x73\x3a\x72\x64\x66\x3d\x22\x68\x74\x74\x70\x3a\x2f\x2f\x77\x77\x77\x2e\x77\x33\x2e\x6f\x72\x67\x2f\x31\x39\x39\x39\x2f\x30\x32\x2f\x32\x32\x2d\x72\x64\x66\x2d\x73\x79\x6e\x74\x61\x78\x2d\x6e\x73\x23\x22\x3e\x20\x3c\x72\x64\x66\x3a\x44\x65\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x20\x72\x64\x66\x3a\x61\x62\x6f\x75\x74\x3d\x22\x22\x20\x78\x6d\x6c\x6e\x73\x3a\x78\x6d\x70\x4d\x4d\x3d\x22\x68\x74\x74\x70\x3a\x2f\x2f\x6e\x73\x2e\x61\x64\x6f\x62\x65\x2e\x63\x6f\x6d\x2f\x78\x61\x70\x2f\x31\x2e\x30\x2f\x6d\x6d\x2f\x22\x20\x78\x6d\x6c\x6e\x73\x3a\x73\x74\x52\x65\x66\x3d\x22\x68\x74\x74\x70\x3a\x2f\x2f\x6e\x73\x2e\x61\x64\x6f\x62\x65\x2e\x63\x6f\x6d\x2f\x78\x61\x70\x2f\x31\x2e\x30\x2f\x73\x54\x79\x70\x65\x2f\x52\x65\x73\x6f\x75\x72\x63\x65\x52\x65\x66\x23\x22\x20\x78\x6d\x6c\x6e\x73\x3a\x78\x6d\x70\x3d\x22\x68\x74\x74\x70\x3a\x2f\x2f\x6e\x73\x2e\x61\x64\x6f\x62\x65\x2e\x63\x6f\x6d\x2f\x78\x61\x70\x2f\x31\x2e\x30\x2f\x22\x20\x78\x6d\x70\x4d\x4d\x3a\x4f\x72\x69\x67\x69\x6e\x61\x6c\x44\x6f\x63\x75\x6d\x65\x6e\x74\x49\x44\x3d\x22\x78\x6d\x70\x2e\x64\x69\x64\x3a\x39\x46\x43\x45\x44\x33\x38\x38\x39\x43\x37\x30\x45\x32\x31\x31\x41\x33\x44\x34\x45\x37\x34\x46\x39\x37\x44\x37\x43\x37\x34\x43\x22\x20\x78\x6d\x70\x4d\x4d\x3a\x44\x6f\x63\x75\x6d\x65\x6e\x74\x49\x44\x3d\x22\x78\x6d\x70\x2e\x64\x69\x64\x3a\x34\x32\x37\x31\x30\x30\x32\x42\x37\x32\x46\x41\x31\x31\x45\x32\x38\x36\x42\x34\x38\x37\x31\x46\x39\x45\x41\x30\x45\x41\x42\x33\x22\x20\x78\x6d\x70\x4d\x4d\x3a\x49\x6e\x73\x74\x61\x6e\x63\x65\x49\x44\x3d\x22\x78\x6d\x70\x2e\x69\x69\x64\x3a\x34\x32\x37\x31\x30\x30\x32\x41\x37\x32\x46\x41\x31\x31\x45\x32\x38\x36\x42\x34\x38\x37\x31\x46\x39\x45\x41\x30\x45\x41\x42\x33\x22\x20\x78\x6d\x70\x3a\x43\x72\x65\x61\x74\x6f\x72\x54\x6f\x6f\x6c\x3d\x22\x41\x64\x6f\x62\x65\x20\x50\x68\x6f\x74\x6f\x73\x68\x6f\x70\x20\x43\x53\x35\x2e\x31\x20\x57\x69\x6e\x64\x6f\x77\x73\x22\x3e\x20\x3c\x78\x6d\x70\x4d\x4d\x3a\x44\x65\x72\x69\x76\x65\x64\x46\x72\x6f\x6d\x20\x73\x74\x52\x65\x66\x3a\x69\x6e\x73\x74\x61\x6e\x63\x65\x49\x44\x3d\x22\x78\x6d\x70\x2e\x69\x69\x64\x3a\x45\x42\x41\x32\x38\x45\x46\x41\x46\x38\x37\x32\x45\x32\x31\x31\x38\x30\x38\x44\x44\x39\x41\x30\x39\x38\x38\x36\x46\x37\x45\x45\x22\x20\x73\x74\x52\x65\x66\x3a\x64\x6f\x63\x75\x6d\x65\x6e\x74\x49\x44\x3d\x22\x78\x6d\x70\x2e\x64\x69\x64\x3a\x39\x46\x43\x45\x44\x33\x38\x38\x39\x43\x37\x30\x45\x32\x31\x31\x41\x33\x44\x34\x45\x37\x34\x46\x39\x37\x44\x37\x43\x37\x34\x43\x22\x2f\x3e\x20\x3c\x2f\x72\x64\x66\x3a\x44\x65\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x3e\x20\x3c\x2f\x72\x64\x66\x3a\x52\x44\x46\x3e\x20\x3c\x2f\x78\x3a\x78\x6d\x70\x6d\x65\x74\x61\x3e\x20\x3c\x3f\x78\x70\x61\x63\x6b\x65\x74\x20\x65\x6e\x64\x3d\x22\x72\x22\x3f\x3e\x7b\xcb\x6b\xcb\x00\x00\x03\xe4\x49\x44\x41\x54\x78\xda\xd4\x55\x4d\x48\x54\x51\x14\x3e\xf7\x8d\xf8\xd4\xfc\x41\x04\xd3\x65\x0b\x47\x6d\xe1\xde\x44\xaa\x61\x84\x69\x95\x21\xd8\x54\xba\x30\x44\x1a\x6c\xe5\xde\xa0\xd4\x85\xc2\x38\xda\x8f\x05\x4d\x20\x29\x24\xe6\xca\x95\x3f\xd4\x2a\x91\xa2\x59\x28\x11\x41\xcc\x84\x36\x0a\x2e\xc6\x0a\xc6\xbf\x70\xbc\xdd\x73\xdf\xbb\x77\xee\x7b\xf3\xa0\xc6\x5a\xe4\xd5\xf3\xee\x7d\xe7\x9e\x73\xee\x77\xce\xf9\xee\x1b\x42\x29\x05\x75\x2c\x2e\x2e\x56\x15\x17\x17\x07\xd8\xf2\x12\x93\x33\x4c\x74\xf8\xbf\xc7\x01\x93\x18\xcb\x63\x2e\x95\x4a\x3d\x6e\x68\x68\xf8\xac\x6e\x12\x91\xe0\xec\xec\xac\x76\xea\x54\xe1\xfd\xfd\x83\xbd\x00\xa1\xa0\xa1\x96\x80\xf9\xa0\xfc\xdf\x36\xcc\x0d\xcb\x9b\xa9\x23\x18\xd8\x58\x53\xfb\x3e\xc1\x60\x84\xad\xd2\x7b\x96\x50\x44\x3d\xd0\xe9\x8c\xcc\x59\xfa\x51\x7a\x94\xa7\xeb\x4f\x73\x75\xbd\xbb\xb1\xb1\x31\x25\x13\x9c\x99\x99\xd1\xf6\xf6\xf7\xe7\x77\x77\x92\x5e\x33\x2d\x40\x3d\x61\x4e\x94\xe3\x35\x40\x23\x40\x13\x9f\x02\x50\x40\x27\xc6\xa1\xe6\x83\x8a\x24\x88\x88\x48\x24\x28\x01\x4f\xa6\x88\xb6\x44\x20\x35\x7c\x65\xb9\xb8\xbf\xf0\x32\x4f\xa4\x86\x2f\x91\x1d\x90\x9e\xfc\x7c\xd6\xa8\xd7\x15\x95\x15\x4d\x5e\xaf\xf7\x28\x07\x37\x36\x37\x37\x1f\x6c\x6c\x6c\x78\x15\x4b\x81\x54\x55\x58\xb6\xc5\x8a\xa8\x90\x2d\x66\x69\xf0\xa2\x20\x22\x5b\xc7\xc8\x8a\x32\xdd\x1d\x2a\x8b\x03\x56\x70\x16\x2e\x51\xa5\x7c\x46\x92\xc4\x93\xd8\x4e\xdc\x67\x09\xde\x26\xa1\xd0\x88\x7b\xe9\xcd\x9b\x8f\x47\xf4\xc8\x45\x24\x85\x9c\x28\x99\x49\xd0\x5b\x81\x00\xb0\x20\xb0\xbc\xbc\x0c\xcf\xc2\x61\xf8\xfe\xfd\x07\x3f\x60\x72\x72\x12\x86\x86\x86\x60\x75\x75\x15\x14\xd6\xf2\x98\x2d\x2d\x2d\xe0\xf3\xf9\x20\x3f\x3f\x1f\x16\x16\x16\xe0\xf9\xc4\x84\x89\x52\xa5\xa2\x09\x94\xfd\x4d\x4c\x4e\xc8\x58\x56\x4a\x2a\x71\x1d\x38\xcb\xd8\x97\xba\x70\xfe\xc2\xd9\x9c\x48\xe4\x7d\x20\x1a\x8b\xba\x04\x15\xd3\x64\xb3\x3a\xf2\xa5\x50\x30\x6e\xf4\xdd\xbb\x0b\x55\x55\x55\xd0\xd6\xd6\x06\x03\x03\x03\x70\xb9\xf9\x0a\xdc\xb9\xd3\xcb\xf7\x10\xfc\xe1\xe1\x21\xc4\x62\x31\xf3\x6a\x18\x85\xbb\x71\xfd\x06\x34\x37\x37\xc3\xd8\xd8\x18\xac\xaf\xaf\x41\x7d\xfd\x39\xf8\x12\x8b\x9a\xb9\x11\x13\x2c\x95\xd7\x00\x8f\xb2\xc6\xe2\xc1\x24\x6d\xd3\x98\x1d\xaf\xae\x4b\xcf\xcb\x0b\xe4\xbc\x7b\xf7\xd6\xb7\x9d\xf8\x96\xc9\x13\xdb\x8d\x51\xe9\x88\xe3\xe2\x45\x0f\x0c\x0f\x0f\xc3\xfc\xfc\x3c\x54\x57\x57\x43\x4f\x4f\x0f\xdc\xbc\x19\x97\x15\xdc\xd9\xd9\x81\xf8\xd7\xb8\x71\x1f\x4d\xf8\xd8\xbd\xe9\x97\x2f\x61\x70\x70\x90\xdb\xbd\x78\x31\x65\xa3\xa4\x9d\x7c\x4a\xac\x78\xdc\x81\xa4\x66\x43\xa8\x51\x74\x4a\x95\xef\x0d\xf7\xdb\xf5\x81\xcb\xe5\x3a\x30\x7d\xfe\x58\x3c\x1e\x0f\xa5\xc6\xe7\x57\x0a\x0e\xbf\xdf\x2f\xd7\xdd\xdd\xdd\x34\x1a\x8d\xd2\x70\x38\xcc\x75\x6e\xb7\xdb\x62\x63\x17\xd4\xa3\x3d\x8a\x6a\x23\x62\x65\x8b\x11\x05\x73\xd3\xec\xbf\x83\x7f\x32\x6a\x6b\x6b\x1d\xf5\x65\x65\x65\x72\xdd\xd5\xd5\xc5\xe7\xce\xce\x4e\x3e\x37\x35\x35\xf1\x79\x6a\x6a\xca\xd1\x77\x74\x74\x14\x22\x91\x08\x17\x5c\xff\x8b\xa1\x69\xda\x4f\xad\xa0\xa0\x20\x96\xad\x63\x22\x91\xf8\xad\xbe\xae\xae\x0e\xc6\xc7\xc7\x1d\xed\x58\x57\xf9\xcf\x90\x28\x2e\xeb\x18\x94\x97\x97\x43\x6b\x6b\x2b\x17\x5c\xb3\xae\xfd\x75\x82\xba\xae\xaf\x41\x65\x65\x65\xe8\x38\xed\x4f\x26\x93\xb4\xb7\xb7\x97\xaf\x71\xc6\x77\x95\x56\x5b\x5b\x5b\x74\x6e\x6e\x2e\x83\xc6\x82\x6e\x38\x0b\x9a\x23\x25\x55\xca\xab\x54\x46\x8a\x23\xbd\x8f\x83\xb1\xfc\xf4\xe9\x11\x68\xbd\x7a\xb5\x86\x7d\x9d\x0e\xb3\x75\x9e\x9e\x9e\xe6\xf7\x05\xef\x23\xce\xf8\xae\x02\x0c\x06\x83\x19\xf7\x67\x69\x69\x89\xdb\x62\x41\x50\xd4\xa4\xb0\x20\x98\x0c\x0a\xae\x85\x5e\xd8\x67\x8b\x0f\x73\xf2\x5f\xf3\xd7\x70\x9a\x94\x96\x96\x3e\xca\x36\x00\x56\x15\x3b\x84\x43\x4d\x4e\x74\x17\x3b\x80\xfa\x95\x95\x95\x0c\x1f\x4c\x00\x45\xf5\x43\x7b\xd4\xd9\x3f\x32\xc7\x4d\xb0\xa4\xa4\xe4\x11\xaf\x1f\x3e\xfa\xfa\xfa\xb4\xdc\xdc\xdc\xc5\xe3\xd0\xe0\x7f\x14\x96\xcb\xab\x50\x28\xa4\xc9\x04\x51\xfa\xfb\xfb\xb5\xa2\xa2\xa2\x87\xcc\x20\x75\x82\x93\x4b\x15\x16\x16\x3e\x09\x06\x87\x5d\xf2\x23\x26\x16\x42\xda\xdb\xdb\xdd\x2c\xd1\x11\xc6\xe1\x4f\xcc\xe1\xe7\x09\x48\x2a\xc9\xb0\x7e\x40\xcc\x1d\x1d\x1d\x35\xf6\x7c\x7e\x09\x30\x00\x8d\x29\x99\xf1\x41\xd7\xf5\xf7\x00\x00\x00\x00\x49\x45\x4e\x44\xae\x42\x60' +
               '\x82',
      strNo:   '\x89\x50\x4e\x47\x0d\x0a\x1a\x0a\x00\x00\x00\x0d\x49\x48\x44\x52\x00\x00\x00\x38\x00\x00\x00\x10\x08\x06\x00\x00\x00\x43\x79\xbc\x45\x00\x00\x00\x19\x74\x45\x58\x74\x53\x6f\x66\x74\x77\x61\x72\x65\x00\x41\x64\x6f\x62\x65\x20\x49\x6d\x61\x67\x65\x52\x65\x61\x64\x79\x71\xc9\x65\x3c\x00\x00\x03\x66\x69\x54\x58\x74\x58\x4d\x4c\x3a\x63\x6f\x6d\x2e\x61\x64\x6f\x62\x65\x2e\x78\x6d\x70\x00\x00\x00\x00\x00\x3c\x3f\x78\x70\x61\x63\x6b\x65\x74\x20\x62\x65\x67\x69\x6e\x3d\x22\xef\xbb\xbf\x22\x20\x69\x64\x3d\x22\x57\x35\x4d\x30\x4d\x70\x43\x65\x68\x69\x48\x7a\x72\x65\x53\x7a\x4e\x54\x63\x7a\x6b\x63\x39\x64\x22\x3f\x3e\x20\x3c\x78\x3a\x78\x6d\x70\x6d\x65\x74\x61\x20\x78\x6d\x6c\x6e\x73\x3a\x78\x3d\x22\x61\x64\x6f\x62\x65\x3a\x6e\x73\x3a\x6d\x65\x74\x61\x2f\x22\x20\x78\x3a\x78\x6d\x70\x74\x6b\x3d\x22\x41\x64\x6f\x62\x65\x20\x58\x4d\x50\x20\x43\x6f\x72\x65\x20\x35\x2e\x33\x2d\x63\x30\x31\x31\x20\x36\x36\x2e\x31\x34\x35\x36\x36\x31\x2c\x20\x32\x30\x31\x32\x2f\x30\x32\x2f\x30\x36\x2d\x31\x34\x3a\x35\x36\x3a\x32\x37\x20\x20\x20\x20\x20\x20\x20\x20\x22\x3e\x20\x3c\x72\x64\x66\x3a\x52\x44\x46\x20\x78\x6d\x6c\x6e\x73\x3a\x72\x64\x66\x3d\x22\x68\x74\x74\x70\x3a\x2f\x2f\x77\x77\x77\x2e\x77\x33\x2e\x6f\x72\x67\x2f\x31\x39\x39\x39\x2f\x30\x32\x2f\x32\x32\x2d\x72\x64\x66\x2d\x73\x79\x6e\x74\x61\x78\x2d\x6e\x73\x23\x22\x3e\x20\x3c\x72\x64\x66\x3a\x44\x65\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x20\x72\x64\x66\x3a\x61\x62\x6f\x75\x74\x3d\x22\x22\x20\x78\x6d\x6c\x6e\x73\x3a\x78\x6d\x70\x4d\x4d\x3d\x22\x68\x74\x74\x70\x3a\x2f\x2f\x6e\x73\x2e\x61\x64\x6f\x62\x65\x2e\x63\x6f\x6d\x2f\x78\x61\x70\x2f\x31\x2e\x30\x2f\x6d\x6d\x2f\x22\x20\x78\x6d\x6c\x6e\x73\x3a\x73\x74\x52\x65\x66\x3d\x22\x68\x74\x74\x70\x3a\x2f\x2f\x6e\x73\x2e\x61\x64\x6f\x62\x65\x2e\x63\x6f\x6d\x2f\x78\x61\x70\x2f\x31\x2e\x30\x2f\x73\x54\x79\x70\x65\x2f\x52\x65\x73\x6f\x75\x72\x63\x65\x52\x65\x66\x23\x22\x20\x78\x6d\x6c\x6e\x73\x3a\x78\x6d\x70\x3d\x22\x68\x74\x74\x70\x3a\x2f\x2f\x6e\x73\x2e\x61\x64\x6f\x62\x65\x2e\x63\x6f\x6d\x2f\x78\x61\x70\x2f\x31\x2e\x30\x2f\x22\x20\x78\x6d\x70\x4d\x4d\x3a\x4f\x72\x69\x67\x69\x6e\x61\x6c\x44\x6f\x63\x75\x6d\x65\x6e\x74\x49\x44\x3d\x22\x78\x6d\x70\x2e\x64\x69\x64\x3a\x39\x46\x43\x45\x44\x33\x38\x38\x39\x43\x37\x30\x45\x32\x31\x31\x41\x33\x44\x34\x45\x37\x34\x46\x39\x37\x44\x37\x43\x37\x34\x43\x22\x20\x78\x6d\x70\x4d\x4d\x3a\x44\x6f\x63\x75\x6d\x65\x6e\x74\x49\x44\x3d\x22\x78\x6d\x70\x2e\x64\x69\x64\x3a\x33\x36\x35\x45\x30\x30\x45\x38\x37\x32\x46\x41\x31\x31\x45\x32\x41\x38\x37\x45\x45\x35\x45\x39\x44\x42\x36\x39\x41\x43\x39\x44\x22\x20\x78\x6d\x70\x4d\x4d\x3a\x49\x6e\x73\x74\x61\x6e\x63\x65\x49\x44\x3d\x22\x78\x6d\x70\x2e\x69\x69\x64\x3a\x33\x36\x35\x45\x30\x30\x45\x37\x37\x32\x46\x41\x31\x31\x45\x32\x41\x38\x37\x45\x45\x35\x45\x39\x44\x42\x36\x39\x41\x43\x39\x44\x22\x20\x78\x6d\x70\x3a\x43\x72\x65\x61\x74\x6f\x72\x54\x6f\x6f\x6c\x3d\x22\x41\x64\x6f\x62\x65\x20\x50\x68\x6f\x74\x6f\x73\x68\x6f\x70\x20\x43\x53\x35\x2e\x31\x20\x57\x69\x6e\x64\x6f\x77\x73\x22\x3e\x20\x3c\x78\x6d\x70\x4d\x4d\x3a\x44\x65\x72\x69\x76\x65\x64\x46\x72\x6f\x6d\x20\x73\x74\x52\x65\x66\x3a\x69\x6e\x73\x74\x61\x6e\x63\x65\x49\x44\x3d\x22\x78\x6d\x70\x2e\x69\x69\x64\x3a\x45\x42\x41\x32\x38\x45\x46\x41\x46\x38\x37\x32\x45\x32\x31\x31\x38\x30\x38\x44\x44\x39\x41\x30\x39\x38\x38\x36\x46\x37\x45\x45\x22\x20\x73\x74\x52\x65\x66\x3a\x64\x6f\x63\x75\x6d\x65\x6e\x74\x49\x44\x3d\x22\x78\x6d\x70\x2e\x64\x69\x64\x3a\x39\x46\x43\x45\x44\x33\x38\x38\x39\x43\x37\x30\x45\x32\x31\x31\x41\x33\x44\x34\x45\x37\x34\x46\x39\x37\x44\x37\x43\x37\x34\x43\x22\x2f\x3e\x20\x3c\x2f\x72\x64\x66\x3a\x44\x65\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x3e\x20\x3c\x2f\x72\x64\x66\x3a\x52\x44\x46\x3e\x20\x3c\x2f\x78\x3a\x78\x6d\x70\x6d\x65\x74\x61\x3e\x20\x3c\x3f\x78\x70\x61\x63\x6b\x65\x74\x20\x65\x6e\x64\x3d\x22\x72\x22\x3f\x3e\x68\x39\xdd\x9f\x00\x00\x03\xfc\x49\x44\x41\x54\x78\xda\xd4\x56\x4f\x48\x5b\x49\x18\xff\xe6\x45\x7c\xfe\x17\x11\xa4\x3d\xf6\x60\x5c\x85\xed\x55\xf0\x4f\x1b\x43\x0a\xed\x41\xba\x7b\x52\x44\x41\x8b\x87\x0d\xee\x49\xc1\x93\x5a\xb6\xea\x45\x88\xa9\x6d\xc3\xb6\x54\xf1\xd0\x20\x22\xe2\x41\x41\x22\xee\x2e\x08\x59\x64\xcb\xf6\xa0\x2e\xcb\xc2\x92\xd4\xdd\x44\x45\x21\xdd\x16\x62\xab\xc5\x38\x9d\x6f\xde\x9b\xc9\xbc\x24\xbb\xeb\xa3\x97\xf6\x23\xf3\x66\xde\xf7\x67\xe6\xf7\x9b\xf9\xe6\x7b\x21\x94\x52\x50\x65\x7d\x7d\xbd\xba\xac\xac\xcc\xcb\x86\xb7\x58\xbb\xc2\x9a\x0e\x9f\xb6\x9c\xb2\x16\x65\x3c\x42\xa9\x54\xea\xfb\xc6\xc6\xc6\x3f\x55\x23\x11\x04\x97\x97\x97\xb5\xe2\xe2\x92\x07\x27\xa7\xef\xbc\x84\x82\x86\x5a\x02\xe6\x83\xf2\x5f\x86\x98\x06\xcb\x9b\xa9\x23\x38\xb1\x31\xa6\x99\x76\x82\x93\x11\x36\x4a\xdb\x2c\x53\x11\x75\xc1\x5c\x6b\x64\xf7\x32\x8e\xd2\xf3\x02\x5d\x7f\x9a\xaf\xeb\x7d\xcd\xcd\xcd\x29\x49\x70\x71\x71\x51\x7b\x77\x72\xb2\xf6\xf6\x38\xe9\x31\x69\x01\xea\x09\x0b\xa2\x1c\xaf\x01\x1a\x01\x9a\xf8\x14\x80\x02\x3a\x31\x16\x35\x1f\x54\x90\x20\x62\x46\x22\x41\x09\x78\x92\x22\xfa\x12\x81\xd4\x88\x95\xdb\xc5\xe3\x45\x94\xb9\x22\x35\x62\x89\x3c\x01\x19\xc9\xd7\x67\x07\xf5\xd3\xa5\xcb\x97\x6e\x78\x3c\x9e\xf3\x3c\x34\xec\xef\xef\x3f\xdc\xdb\xdb\xf3\x28\x9e\x02\xa9\xaa\xb0\x98\xc5\x88\xa8\x90\x2d\x6e\x69\xf0\x62\x43\x04\xdb\x9c\x33\x2b\xca\xf4\xe9\x50\xb9\x39\x60\x05\x67\xc9\x25\xaa\x6c\x9f\x41\x92\xb8\x13\xaf\x12\x0f\x18\xc1\x6f\x89\xdf\x7f\xdf\xf9\x73\x38\xfc\xfb\x39\x3d\x77\x10\x99\x42\xb9\x52\x32\x3b\x41\xbf\xf1\x7a\x81\x4d\x02\x9b\x9b\x9b\x30\x33\x3d\x0d\xaf\x5f\xbf\xe1\x0b\x04\x83\x41\x98\x98\x98\x80\xed\xed\x6d\x50\xb2\x16\xbe\xbc\x7a\x15\x06\x07\x07\x61\x68\x68\x08\x76\x77\x77\xd3\x7e\x3b\x3b\x00\x54\x4d\x45\x13\xa8\x09\x3b\x18\x7c\xc6\xfd\x76\xd8\x7c\x99\x69\x2d\x4e\x39\x33\x67\x59\xf6\xa5\x5c\xd7\x5d\x75\x79\x2f\x5e\xfc\xea\x8d\x44\x23\x0e\x91\x8a\xe9\x69\xad\x81\x7c\x28\x14\x2c\x37\x46\xef\x7d\x07\xd5\xd5\xd5\xd0\xd9\xd9\x09\xe3\xe3\xe3\x70\xfb\xab\xaf\x61\x64\x64\x98\xdb\x0a\x0b\x0b\xe1\xec\xec\x0c\xa2\xd1\xa8\x79\x35\x8c\x8d\xab\xad\xab\xe3\x36\x97\xcb\x05\x77\xef\x8e\xa4\xfd\x22\x11\x10\x89\x48\x09\x95\xd7\x40\xac\x2d\xfd\x5e\xbe\xe4\x1b\x21\xd2\x36\x8d\x39\xe7\xd5\x75\xe8\x05\x05\xde\xbc\xe7\xcf\x7f\xb9\xf9\x2a\xf1\x4f\x76\x9e\x64\xdc\x18\x35\x1d\x51\x5a\x5a\xdc\x30\x39\x39\x09\x6b\x6b\x6b\x50\x53\x53\x03\xfd\xfd\xfd\x70\xe7\x4e\x5c\xee\xe0\xf1\xf1\x31\xc4\x63\x71\xe3\x3e\x9a\xf0\x51\x87\x52\x5f\x5f\x0f\xb1\xbf\xe3\xd2\x2f\x16\x8f\x5b\x0a\x47\x2e\xe1\x7e\xb1\x58\x16\x32\xa3\x2e\x18\x9b\x4e\xa9\x52\x6f\x78\xcc\xdb\x9b\xe0\x70\x38\x4e\xcd\x98\x0b\x37\xb7\xdb\x4d\xa9\x51\x7e\x65\x43\x69\x6f\x6f\x97\xe3\xad\xad\x2d\xde\xfb\x7c\x3e\xe9\xd3\xd7\xd7\xc7\x75\x87\x87\x87\x72\x8c\xbd\xb0\x63\x3c\xda\x30\xd6\xe9\x74\x5a\xe6\x56\xfd\x2e\xda\x90\x9b\x96\xf9\x1d\xbc\x88\xd4\xd6\xd6\xe6\xd4\x57\x56\x56\xca\xf1\xc1\xc1\x01\x3f\x61\x3c\x59\xb6\x21\x16\xbf\x8d\x8d\x0d\x68\x6d\x6d\xcd\x8a\x9f\x9a\x9a\x82\x95\x95\x15\x48\x26\x93\x30\x3b\x3b\xfb\xd1\x1f\x48\x4d\xd3\xde\x6b\x45\x45\x45\x51\xbb\x81\x89\x44\xe2\x7f\xf5\x08\x74\x60\x60\x20\xe7\x86\x2c\x2d\x2d\x41\x53\x53\x93\x45\xc7\x4e\x0f\xaa\xaa\xaa\xa0\xb7\xb7\x17\xe6\xe6\xe6\xa0\xa1\xa1\xe1\xa3\x09\xea\xba\xfe\x97\x56\x5a\x5a\x1a\xb2\x1b\x38\x3f\x3f\xcf\xef\xc4\xf0\xf0\x30\x7f\xc7\x1e\xdf\x51\x6f\x27\xfe\xdf\x4e\x5f\xdc\x39\x21\x33\x33\x33\xf8\x0f\xcb\x36\xc1\xa2\xe2\xe2\x1f\xb4\xe6\x6b\xd7\x9e\x60\x49\xb5\x1b\xbc\xba\xba\x0a\xdd\xdd\xdd\x3c\xfd\xb0\xc7\x77\x3b\x82\x27\xac\x4a\x20\x10\x80\xa3\xa3\x23\x98\x66\x9f\x9b\x8e\x8e\x0e\x08\x87\xc3\x4a\x41\x6b\x81\xb6\xb6\x36\x5b\xf3\x23\x27\xb7\xbb\xe5\x31\xff\xc7\x52\x51\x51\x11\xb0\x7b\x81\xb1\x08\x84\x42\x21\x5e\x00\x16\x16\x16\x2c\x36\x76\x87\x64\xc1\x51\xc7\xd8\xe3\xbb\x28\x54\xaa\xed\xbf\x8a\x4c\x24\x12\xa1\x2c\x4b\x6c\xe1\x2b\x2f\x2f\x0f\xf0\xfa\x82\x8f\xd1\xd1\x51\x2d\x3f\x3f\x7f\xdd\x2e\xc9\x4f\xb5\x31\x2e\x3f\xfa\xfd\x7e\x4d\x12\xc4\x36\x36\x36\x86\xf7\xf1\x11\x73\x48\x7d\xc6\xe4\x52\x25\x25\x25\x8f\x7d\xbe\x49\x87\xe0\x25\x09\x8a\xd6\xd5\xd5\xe5\x64\x44\xef\xb3\x1c\xfe\x83\x05\xbc\xff\x0c\x48\x25\x19\xd6\xdf\x10\x73\x4f\x4f\xcf\x17\x99\x7c\x3e\x08\x30\x00\x4c\xbe\x1d\x9c\x2b\xef\x55\xf2\x00\x00\x00\x00\x49\x45\x4e\x44\xae\x42\x60' +
               '\x82',
      strHelp: '\x89\x50\x4e\x47\x0d\x0a\x1a\x0a\x00\x00\x00\x0d\x49\x48\x44\x52\x00\x00\x00\x38\x00\x00\x00\x10\x08\x06\x00\x00\x00\x43\x79\xbc\x45\x00\x00\x00\x19\x74\x45\x58\x74\x53\x6f\x66\x74\x77\x61\x72\x65\x00\x41\x64\x6f\x62\x65\x20\x49\x6d\x61\x67\x65\x52\x65\x61\x64\x79\x71\xc9\x65\x3c\x00\x00\x03\x66\x69\x54\x58\x74\x58\x4d\x4c\x3a\x63\x6f\x6d\x2e\x61\x64\x6f\x62\x65\x2e\x78\x6d\x70\x00\x00\x00\x00\x00\x3c\x3f\x78\x70\x61\x63\x6b\x65\x74\x20\x62\x65\x67\x69\x6e\x3d\x22\xef\xbb\xbf\x22\x20\x69\x64\x3d\x22\x57\x35\x4d\x30\x4d\x70\x43\x65\x68\x69\x48\x7a\x72\x65\x53\x7a\x4e\x54\x63\x7a\x6b\x63\x39\x64\x22\x3f\x3e\x20\x3c\x78\x3a\x78\x6d\x70\x6d\x65\x74\x61\x20\x78\x6d\x6c\x6e\x73\x3a\x78\x3d\x22\x61\x64\x6f\x62\x65\x3a\x6e\x73\x3a\x6d\x65\x74\x61\x2f\x22\x20\x78\x3a\x78\x6d\x70\x74\x6b\x3d\x22\x41\x64\x6f\x62\x65\x20\x58\x4d\x50\x20\x43\x6f\x72\x65\x20\x35\x2e\x33\x2d\x63\x30\x31\x31\x20\x36\x36\x2e\x31\x34\x35\x36\x36\x31\x2c\x20\x32\x30\x31\x32\x2f\x30\x32\x2f\x30\x36\x2d\x31\x34\x3a\x35\x36\x3a\x32\x37\x20\x20\x20\x20\x20\x20\x20\x20\x22\x3e\x20\x3c\x72\x64\x66\x3a\x52\x44\x46\x20\x78\x6d\x6c\x6e\x73\x3a\x72\x64\x66\x3d\x22\x68\x74\x74\x70\x3a\x2f\x2f\x77\x77\x77\x2e\x77\x33\x2e\x6f\x72\x67\x2f\x31\x39\x39\x39\x2f\x30\x32\x2f\x32\x32\x2d\x72\x64\x66\x2d\x73\x79\x6e\x74\x61\x78\x2d\x6e\x73\x23\x22\x3e\x20\x3c\x72\x64\x66\x3a\x44\x65\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x20\x72\x64\x66\x3a\x61\x62\x6f\x75\x74\x3d\x22\x22\x20\x78\x6d\x6c\x6e\x73\x3a\x78\x6d\x70\x4d\x4d\x3d\x22\x68\x74\x74\x70\x3a\x2f\x2f\x6e\x73\x2e\x61\x64\x6f\x62\x65\x2e\x63\x6f\x6d\x2f\x78\x61\x70\x2f\x31\x2e\x30\x2f\x6d\x6d\x2f\x22\x20\x78\x6d\x6c\x6e\x73\x3a\x73\x74\x52\x65\x66\x3d\x22\x68\x74\x74\x70\x3a\x2f\x2f\x6e\x73\x2e\x61\x64\x6f\x62\x65\x2e\x63\x6f\x6d\x2f\x78\x61\x70\x2f\x31\x2e\x30\x2f\x73\x54\x79\x70\x65\x2f\x52\x65\x73\x6f\x75\x72\x63\x65\x52\x65\x66\x23\x22\x20\x78\x6d\x6c\x6e\x73\x3a\x78\x6d\x70\x3d\x22\x68\x74\x74\x70\x3a\x2f\x2f\x6e\x73\x2e\x61\x64\x6f\x62\x65\x2e\x63\x6f\x6d\x2f\x78\x61\x70\x2f\x31\x2e\x30\x2f\x22\x20\x78\x6d\x70\x4d\x4d\x3a\x4f\x72\x69\x67\x69\x6e\x61\x6c\x44\x6f\x63\x75\x6d\x65\x6e\x74\x49\x44\x3d\x22\x78\x6d\x70\x2e\x64\x69\x64\x3a\x39\x46\x43\x45\x44\x33\x38\x38\x39\x43\x37\x30\x45\x32\x31\x31\x41\x33\x44\x34\x45\x37\x34\x46\x39\x37\x44\x37\x43\x37\x34\x43\x22\x20\x78\x6d\x70\x4d\x4d\x3a\x44\x6f\x63\x75\x6d\x65\x6e\x74\x49\x44\x3d\x22\x78\x6d\x70\x2e\x64\x69\x64\x3a\x32\x34\x36\x46\x45\x35\x42\x32\x37\x32\x46\x41\x31\x31\x45\x32\x39\x32\x33\x30\x42\x30\x44\x37\x39\x32\x32\x44\x36\x33\x35\x36\x22\x20\x78\x6d\x70\x4d\x4d\x3a\x49\x6e\x73\x74\x61\x6e\x63\x65\x49\x44\x3d\x22\x78\x6d\x70\x2e\x69\x69\x64\x3a\x32\x34\x36\x46\x45\x35\x42\x31\x37\x32\x46\x41\x31\x31\x45\x32\x39\x32\x33\x30\x42\x30\x44\x37\x39\x32\x32\x44\x36\x33\x35\x36\x22\x20\x78\x6d\x70\x3a\x43\x72\x65\x61\x74\x6f\x72\x54\x6f\x6f\x6c\x3d\x22\x41\x64\x6f\x62\x65\x20\x50\x68\x6f\x74\x6f\x73\x68\x6f\x70\x20\x43\x53\x35\x2e\x31\x20\x57\x69\x6e\x64\x6f\x77\x73\x22\x3e\x20\x3c\x78\x6d\x70\x4d\x4d\x3a\x44\x65\x72\x69\x76\x65\x64\x46\x72\x6f\x6d\x20\x73\x74\x52\x65\x66\x3a\x69\x6e\x73\x74\x61\x6e\x63\x65\x49\x44\x3d\x22\x78\x6d\x70\x2e\x69\x69\x64\x3a\x45\x42\x41\x32\x38\x45\x46\x41\x46\x38\x37\x32\x45\x32\x31\x31\x38\x30\x38\x44\x44\x39\x41\x30\x39\x38\x38\x36\x46\x37\x45\x45\x22\x20\x73\x74\x52\x65\x66\x3a\x64\x6f\x63\x75\x6d\x65\x6e\x74\x49\x44\x3d\x22\x78\x6d\x70\x2e\x64\x69\x64\x3a\x39\x46\x43\x45\x44\x33\x38\x38\x39\x43\x37\x30\x45\x32\x31\x31\x41\x33\x44\x34\x45\x37\x34\x46\x39\x37\x44\x37\x43\x37\x34\x43\x22\x2f\x3e\x20\x3c\x2f\x72\x64\x66\x3a\x44\x65\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x3e\x20\x3c\x2f\x72\x64\x66\x3a\x52\x44\x46\x3e\x20\x3c\x2f\x78\x3a\x78\x6d\x70\x6d\x65\x74\x61\x3e\x20\x3c\x3f\x78\x70\x61\x63\x6b\x65\x74\x20\x65\x6e\x64\x3d\x22\x72\x22\x3f\x3e\xc5\xb2\xab\xcc\x00\x00\x03\x7b\x49\x44\x41\x54\x78\xda\xdc\x56\xcf\x4b\x1b\x51\x10\x9e\xb7\x1b\xb2\x21\x89\x8a\x27\xcd\x31\x85\x8a\xe6\xe0\x3f\x20\x11\x22\x29\x58\xfc\x03\x3c\x89\x0a\x42\x1b\x92\x93\xa5\x1e\x2b\x56\xaf\x46\x6b\x13\x6a\xa9\x82\xb7\x7a\xf0\x24\x96\x46\xd2\xea\x41\x53\xa8\x56\x7b\xe9\xa1\xd0\x6c\x42\x9b\x28\x78\x88\xb9\x24\xf1\x07\xc4\xed\xbc\xb7\xfb\x36\x9b\xb8\x52\x0d\x85\x6a\x87\xbc\xdd\xb7\x6f\xbe\x99\x37\xdf\xbc\x99\xcd\x12\x45\x51\xc0\x28\xf1\x78\xfc\x7e\x63\x63\x63\x00\xa7\x0f\x71\xb8\x71\x48\x70\xbb\xe5\x0c\x47\x0a\x79\xc4\xca\xe5\xf2\xab\xae\xae\xae\x1f\x46\x25\xe1\x04\x57\x57\x57\x05\x87\xc3\x39\x77\x7a\x76\x12\x20\x0a\x08\x74\x95\x80\x76\x51\xd8\xaf\x46\x34\x45\xd5\x93\xb6\x46\xa8\x63\x75\xae\xd4\xea\x09\x75\x46\x70\x56\xd1\x55\xb9\x22\xc6\x0d\xcd\xf6\xb8\x7c\xd7\xed\x14\xe5\xc2\x26\x49\x6f\xac\x92\x14\xf4\x7a\xbd\x65\x9d\xe0\xca\xca\x8a\x70\x72\x7a\xba\x5e\x2a\x16\xfc\x1a\x2d\xa0\xeb\x04\x8d\x14\x16\xaf\x1a\x34\x0d\x50\x8b\xcf\x10\x20\x0f\x9d\xa8\x9b\x6a\x17\x85\x93\x20\xdc\x23\xd1\x83\xe2\xe1\xe9\x14\x29\x96\xf0\x48\x55\x5b\x3d\x5d\xcc\x9e\x5b\x69\x3b\x2a\xaa\x2d\xd1\x4f\x40\xb7\x64\xfb\xe3\x41\x6d\xb4\xba\x5a\x1f\xf8\xfd\xfe\x0b\x0b\x55\x1c\x1e\x1e\xbe\x3c\x38\x38\xf0\x1b\x90\x3c\x52\xe3\x42\x95\x9a\xca\xf3\x89\x09\x58\x5a\x5a\x82\x74\x3a\x0d\x6e\xb7\x1b\x86\x86\x86\x60\x7c\x7c\x9c\xe9\x26\x50\x67\xb3\xd9\xd8\x7c\x63\x73\x13\xd6\x63\xef\x11\x73\x0f\x06\x11\xf3\x0c\x31\x46\xcf\x4f\x46\x47\xa1\xa5\xa5\x05\x8e\x8e\x8e\x60\x6b\x6b\x0b\x76\x76\x77\x99\x9e\xf9\x1c\xac\xf8\x34\x8b\xc5\x98\x2e\x9e\x34\x4c\x40\x4f\xee\x38\x37\x87\x04\x43\x96\xd9\xd9\x17\x6d\x89\xed\xed\x47\x17\xca\x85\x9a\x29\xa2\x5c\x51\x92\x97\x0b\x94\x12\x28\x95\x4a\x90\x94\x93\x2c\x40\xfa\x9c\x4c\x26\x99\x9e\xce\xc3\xe1\x30\x24\x3e\x25\x78\xd5\x22\xa6\x95\xad\xcb\xb2\x0c\xc0\x7b\x1f\x8f\x81\xda\x52\x6c\x67\x67\x27\xf4\xf5\xf5\xc1\xf2\xdb\x65\x16\x28\xf7\x29\x27\x65\x35\xf0\xaa\x92\xd4\xbb\x01\x14\x93\x9a\x95\x53\xf2\x63\x51\x10\xe7\x2c\x7b\x7b\x5f\x02\xf8\x20\xf2\x52\xac\x14\x5b\xb5\x21\x9b\xf2\x05\x52\xc1\xe4\xf3\x79\x48\xcb\x29\xf0\x74\x78\xd8\x73\x0a\x4f\xb3\x4a\x97\x4a\xa9\x76\x98\xb8\x0e\x8f\x86\x41\x82\x6a\xcb\xd0\xd2\xac\x60\xc7\x9e\x8e\xc1\xfe\xd7\x7d\xc4\x75\xc0\xda\xbb\x35\xf0\x68\x78\x8c\x4f\xcb\x05\x33\xd2\xcb\xb6\x12\xb3\x69\xeb\x8a\x92\xcd\x16\xb0\xec\xec\x7c\xee\x3d\xce\xe5\xb5\x53\x37\x2f\x4b\x8d\xae\xde\x0b\xc6\x32\x2d\x16\x8b\x90\xc9\x66\xd9\x9d\x4a\xf6\x57\x46\x4d\x0c\xd7\x65\x32\x9a\x27\x52\xc1\x20\xbe\xb6\xd2\xa8\x4e\xb0\x88\xfa\x3c\x9b\xc9\x56\xe3\x4d\x8b\x54\x3b\x10\x45\x4d\xba\xa1\x28\x18\xa6\x58\x2c\xf5\x82\x28\x8a\x67\x9a\xcd\x8d\x87\x99\x98\xe9\x16\x16\x16\xd8\x5a\x30\x18\xac\xc2\x18\xb1\x54\x17\x8b\xc5\x94\x42\xa1\xa0\xaf\x5f\x85\xbf\xee\xa0\xdc\x84\xda\xff\xc1\x9b\x4a\x28\x14\x62\xa5\x43\xef\x57\xe9\x46\x46\x46\xfe\xe8\x27\x12\x89\x80\xcb\xe5\xba\x16\xf6\xba\x22\x08\xc2\xb9\xc5\x6e\xb7\xa7\x30\x6b\xed\xff\xfa\xdf\x9a\x26\x23\x1a\x8d\xd6\x7e\x74\xc0\xe2\xe2\x62\xdd\x3e\x25\x49\xfa\x29\x34\x34\x34\xc4\x6e\xeb\x27\x4a\x7f\x7f\x3f\xf8\x7c\xbe\xba\xed\xed\x0e\xc7\x07\xc1\xdb\xdd\xfd\x1a\xcb\xa8\x5c\x8f\x03\xfa\x12\xc8\xe5\x72\x6c\x4e\xef\xfc\xa5\xc0\x75\xb4\xec\x68\x0b\x24\x12\x09\x1d\xc3\x3f\x22\xe8\xc0\xde\xbc\xe4\xe7\x6f\x09\xe5\xd4\xd3\xe3\x9b\x67\x1b\x35\x37\x37\x47\xeb\x6d\xe4\xdb\x3a\x9a\x9a\x9a\xa2\xec\xfd\x42\x2f\x93\x93\x93\x82\xd5\x6a\x8d\xff\x2f\xe4\x90\xcb\xc7\x99\x99\x19\x41\x27\x48\xc7\xd4\xd4\x14\xed\xc7\x08\x02\xca\x77\x98\x5c\xd9\xe9\x74\xce\x4f\x4f\x87\x45\xce\x4b\x27\xc8\xc7\xc0\xc0\x40\x1b\x12\x9d\xc5\x1a\xfe\x8e\x06\xe7\x77\x80\x54\x01\x63\xfd\x46\x63\x1e\x1e\x1e\x6e\xaf\xe5\xf3\x5b\x80\x01\x00\x1d\x66\xf4\xda\x59\x07\x1c\x05\x00\x00\x00\x00\x49\x45\x4e\x44\xae\x42\x60' +
               '\x82',
      //function make .PNG-image from binary data
      make:    function ( pngStr ) {
        var f = File ( Folder.temp.absoluteURI + '/ib' + (+new Date ()) + '.png' );
        f.encoding = 'BINARY';
        f.open ( 'w' );
        f.write ( pngStr );
        f.close ();
        return ScriptUI.newImage ( f.fsName );
      }
    }
  }) ();

  /**============================>>
   * THE SCRIPT *
   ==============================*/
  makeInterface ();

  function makeInterface () {
    var numbOfJpegs = promptNumb ();
//  alert(numbOfJpegs + ' ' + typeof numbOfJpegs); // todo: что то с обработчиками клавиш  esc и cancel
    if ( numbOfJpegs === null ) {
      return;
    }
    mainWin.randStrArr = makeRandStrArr ( numbOfJpegs );
    var exportOpts = {};
    var dialObj = new Dialog ();
    var dialWin = dialObj.makeCarcass ( mainWin );
    var saveVisible = getVisible ( dialObj );

    for ( var i = 0; i < numbOfJpegs; i++ ) {
      exportOpts[ 'set' + i ] = dialObj.addExportSet ( dialWin.setsPanel );
      if ( i < numbOfJpegs - 1 ) {
        dialObj.addSeparator ( dialWin.setsPanel );
      }
    }

    dialWin.exportButt.onClick = function f () {
      makeDir ( dialObj, 'jpg' );
      var allowReplace = true;

      for ( var j = 0; j < numbOfJpegs; j++ ) {

        if ( exportOpts[ 'set' + j ].activateCheck.value &&
          exportOpts[ 'set' + j ].laysList.selection ) {
          setVisible ( exportOpts[ 'set' + j ], dialObj );

          allowReplace = expToJpg ( exportOpts[ 'set' + j ], dialObj, j )

          if ( /*+exportOpts['set' + j].resVal.selection.text != 72 && */allowReplace ) {
            setResolution ( exportOpts[ 'set' + j ], dialObj, j );
          } else if ( allowReplace == false && j < numbOfJpegs - 1 ) {
            continue;
          }// замена файла не подтверждена >> следующий экспорт
          else if ( allowReplace == false && j == numbOfJpegs - 1 ) {
            return;
          } // замена файла не подтверждена >> продолжить работу с диалогом
        }
      }
      setVisible ( saveVisible, dialObj );

      /* var conf = confirm('Save active document?');
       if(conf){
       activeDocument.save();
       }*/
      if ( dialWin.chSaveFile.value == true ) {
        activeDocument.save ();
      }

      dialWin.close ();
    }
    if ( numbOfJpegs == 0 ) {
      return;
    }
    // alert(numbOfJpegs);
    dialObj.showDialog ( dialWin );
  }

  /**============================>>
   * THE CONSTRUCTOR *
   ==============================*/
  function Dialog () {
    var self = this;
    self.ZOOM_IMG_FACTOR = 1.388888888;
    self.laysNames = getLaysNames ();
    self.lays = getAllLays ();
    self.doc = app.activeDocument;
    self.doc.exists ? self.folder = self.doc.path : self.folder = Folder.myDocuments;

    self.makeCarcass = function f ( w ) {

      w.leftCol = w.add ( 'group' );
      w.rightCol = w.add ( 'group' );

      w.setsGroup = w.leftCol.add ( 'group' );
      w.pathGroup = w.leftCol.add ( 'group' );
      w.confGroup = w.leftCol.add ( 'group' );
      w.buttGroup = w.rightCol.add ( 'group' );

      w.setsPanel = w.setsGroup.add ( 'panel', undefined, 'Sets opts' );
      w.scrol = w.setsGroup.add ( 'scrollbar', undefined, 0, 0, 50 );

      w.exportButt = w.buttGroup.add ( "iconbutton", [ 0, 0, 56, 16 ], mainWin.pngBtns.make ( mainWin.pngBtns.strGo ),
                                       { style: 'toolbutton' } );
      w.closeButt = w.buttGroup.add ( "iconbutton", [ 0, 0, 56, 16 ], mainWin.pngBtns.make ( mainWin.pngBtns.strNo ),
                                      { style: 'toolbutton' } );
      w.helpButt = w.buttGroup.add ( 'iconbutton', [ 0, 0, 56, 16 ], mainWin.pngBtns.make ( mainWin.pngBtns.strHelp ),
                                     { style: 'toolbutton' } );

      w.pathTxt = w.pathGroup.add ( 'edittext' );
      w.newDirButt = w.pathGroup.add ( 'button', undefined, 'change folder' );

      w.chConfirm = w.confGroup.add ( 'checkbox', undefined, 'Confirm to replace' );
      w.chDirNearFile = w.confGroup.add ( 'checkbox', undefined, 'jpg-folder near the ai-file' );
      w.chSaveFile = w.confGroup.add ( 'checkbox', undefined, 'save after export' );

      w.orientation = 'row';
      w.leftCol.orientation = 'column';
      w.buttGroup.orientation = 'column';
      w.buttGroup.alignChildren = 'fill'
      w.scrol.preferredSize.width = 20;
      w.setsGroup.alignChildren = 'fill';
      w.setsGroup.spacing = 0;
      w.pathTxt.text = File ( app.activeDocument.path + '../../jpg/' ).fsName;
      w.pathTxt.minimumSize.width = 300;
      w.pathTxt.maximumSize.width = 380;
      w.setsPanel.orientation = 'column';
      w.setsPanel.maximumSize.height = 750 /*720*/;
      w.setsPanel.alignChildren = 'fill';
      w.chConfirm.value = false;
      w.chDirNearFile.value = false;
      w.chSaveFile.value = true;

      w.closeButt.onClick = function f () {
        w.close ();
      }
      w.newDirButt.onClick = function f () {
        mainWin.customDir = self.folder.selectDlg ();
        w.pathTxt.text = mainWin.customDir.fsName;
        w.chDirNearFile.value = false;
        mainWin.dirNearFile = false;
      }
      w.chConfirm.onClick = function () {
        mainWin.replaceYes = w.chConfirm.value;
      }
      w.helpButt.onClick = function () {
        alert_scroll ( mainWin.help.str );
      }
      w.chDirNearFile.onClick = function () {
        if ( mainWin.dirNearFile == false ) {
          mainWin.dirNearFile = true;
          w.pathTxt.text = File ( app.activeDocument.path + '/jpg/' ).fsName;
        } else {
          mainWin.dirNearFile = false;
          w.pathTxt.text = File ( app.activeDocument.path + '../../jpg/' ).fsName;
        }
      }
      /*    w.chSaveFile.onClick = function(e) {
       e.value == true ? w.chSaveFile.value = false : w.chSaveFile.value = true;
       }*/

      return w;
    }
    self.addExportSet = function ( container ) {
      var o = {};
      o.set = container.add ( 'group' );

      o.opts = o.set.add ( 'group' );
      o.lays = o.set.add ( 'group' );

      o.activateSetGroup = o.opts.add ( 'group' );
      o.optsGroups = o.opts.add ( 'group' );

      o.qualGroup = o.optsGroups.add ( 'group' );
      o.cropAndResGroup = o.optsGroups.add ( 'group' );
      o.suffixGroup = o.optsGroups.add ( 'group' );

      o.activateCheck = o.activateSetGroup.add ( 'checkbox' );
      o.activateSetGroupText = o.activateSetGroup.add ( 'statictext', undefined, 'activate' );

      o.gualGroupText = o.qualGroup.add ( 'statictext', undefined, 'quality' );
      o.qualGroupVal = o.qualGroup.add ( 'edittext {text: 6, characters: 3, justify:"center"}' );
      o.qualGroupSlider = o.qualGroup.add ( 'slider', undefined, 6, 0, 10 );

      o.resVal = o.cropAndResGroup.add ( 'dropdownlist', undefined, [ 72, 150, 200, 250, 300, 'custom' ] );
      o.customRes = o.cropAndResGroup.add ( 'edittext {text: 300, characters: 3, justify:"center"}' );
      o.crop = o.cropAndResGroup.add ( 'checkbox', undefined, 'crop to artoard' );

      o.laysList = o.lays.add ( "listbox", undefined, undefined, { multiselect: true } );
      for ( var i = 0; i < getLaysNames ().length; i++ ) {
        o.laysList.add ( "item", getLaysNames ()[ i ] );
      }

      o.laysSuff = o.suffixGroup.add ( 'radiobutton', undefined, 'lays' );
      o.ordinalNumSuff = o.suffixGroup.add ( 'radiobutton', undefined, 'ordinal num' );
      o.randNumSuff = o.suffixGroup.add ( 'radiobutton', undefined, 'random num' );
      o.selfSuff = o.suffixGroup.add ( 'radiobutton', undefined, 'self' );
      o.selfSuffTxt = o.suffixGroup.add ( 'edittext { characters:10}' );

      o.optsGroups.orientation = 'column';
      o.optsGroups.alignChildren = 'left';
      o.laysList.maximumSize.height = 128;
      // o.lays.maximumSize.width = 85;
      o.activateCheck.value = true;
      o.resVal.selection = 1;
      o.resVal.text = 'resolution';
      (getLaysNames ().length == 1) ? o.laysList.selection = 0 : o.laysList.selection = null;
      o.laysSuff.value = true;
      o.customRes.enabled = false;

      o.opts.orientation = 'column';
      o.opts.alignChildren = 'fill';

      o.resVal.addEventListener ( 'change', function ( e ) {
        // alert(o.customRes.text);
        if ( o.resVal.selection.text == 'custom' ) {
          o.customRes.enabled = true;
          o.customRes.active = true;
        } else if ( o.resVal.selection.text != 'custom' ) {
          o.customRes.enabled = false;
          // o.customRes.active = true;
        }
      } )

      o.selfSuffTxt.addEventListener ( 'focus', function () {
        o.selfSuff.value = true
      } )
      o.selfSuff.addEventListener ( 'click', function () {
        o.selfSuffTxt.active = true;
      } )
      o.activateCheck.onClick = function () {
        (o.activateCheck.value == false)
          ? o.lays.enabled = o.optsGroups.enabled = false
          : o.lays.enabled = o.optsGroups.enabled = true;
      }
      o.qualGroup.addEventListener ( 'changing', function ( e ) {
        var targ = e.target;
        if ( targ.text ) {
          targ.parent.children[ 2 ].value = targ.text;
        } else if ( targ.value ) {
          targ.parent.children[ 1 ].text = Math.round ( targ.parent.children[ 2 ].value );
        }
      } )
      return o;
    }
    self.addSeparator = function ( w ) {
      w.add ( 'panel', [ 0, 0, 380, 2 ] );
    }
    self.showDialog = function f ( w ) {
      w.show ();
    }
  }

  /**============================>>
   * THE EXPORT LIBRARY *
   ==============================*/
  function setVisible ( o, w ) {
    var lays = w.lays;
    var arrNames = o.laysList.selection;
    outer:
      for ( var i = 0; i < lays.length; i++ ) {

        for ( var j = 0; j < arrNames.length; j++ ) {
          if ( lays[ i ].name != arrNames[ j ].text ) {
            continue;
          }
          lays[ i ].visible = true;
          continue outer
        }
        lays[ i ].visible = false;
      }
  }

  function getVisible ( w ) {
    var lays = w.lays;
    var visibleLays = {};
    visibleLays.laysList = {};
    visibleLays.laysList.selection = [];

    var j = 0;
    for ( var i = 0; i < lays.length; i++ ) {
      if ( lays[ i ].visible == true ) {
        visibleLays.laysList.selection.push ( { text: '' } );
        visibleLays.laysList.selection[ j ].text = lays[ i ].name;
        j++;
      }
    }
    return visibleLays;
  }

  function expToJpg ( o, w, j ) {
    var props = new ExportOptionsJPEG ();
    var type = ExportType.JPEG;
    var yesToReplace = true;
    mainWin.suffix = setSuffix ( o, w, j );
    var fullPath = getFullName ( mainWin.suffix );
    if ( File ( fullPath ).exists && mainWin.replaceYes ) {
      yesToReplace = confirm (
        'Replace file ' + spaceOnDash ( w.doc.name.slice ( 0,
                                                           -(getFileExt ().length) ) ) + mainWin.suffix + '.jpg' + '?'
      );
    }
    if ( yesToReplace ) {
      var f = new File ( fullPath );

      props.qualitySetting = o.qualGroupVal.text * 10;
      if ( o.resVal.selection.text == 'custom' ) {
        props.horizontalScale = props.verticalScale = o.customRes.text * w.ZOOM_IMG_FACTOR;
      } else if ( o.resVal.selection.text != 'custom' ) {
        props.horizontalScale = props.verticalScale = o.resVal.selection.text * w.ZOOM_IMG_FACTOR;
      }

      props.artBoardClipping = o.crop.value;
      w.doc.exportFile ( f, type, props );
      return true;
    } else {
      return false;
    }
  }

  function setResolution ( o, w ) {
    var jpgPath = getFullName ( mainWin.suffix );
    var res;

    if ( o.resVal.selection.text == 'custom' ) {
      res = +o.customRes.text;
    } else {
      res = +o.resVal.selection.text;
    }

    res > 558 ? res = 558 : '';
    res < 28 ? res = 28 : '';

    if ( File ( jpgPath ).exists ) {
      var f = File ( jpgPath );
    } else {
      return;
    }

    f.encoding = 'BINARY';
    f.open ( 'e' );
    f.seek ( 0 );
    f.write ( "\xff\xd8\xff\xe0\x00\x10\x4a\x46\x49\x46\x00\x01\x02\x01" + _dec2Hex ( res ) + _dec2Hex ( res ) );
    f.close ();

    function _dec2Hex ( res ) {
      var strHex = ('000' + res.toString ( 16 )).slice ( -4 );
      var strByteOne = strHex.slice ( 0, 2 );
      var strByteTwo = strHex.slice ( -2 );
      return (String.fromCharCode ( parseInt ( strByteOne, 16 ) )) + (String.fromCharCode ( parseInt ( strByteTwo,
                                                                                                       16 ) ));
    }
  }

  function makeDir ( w, dirName ) {
    var dir, dirPath;
    if ( mainWin.customDir ) {
      dir = mainWin.customDir;
    } else {
      if ( mainWin.dirNearFile == false ) {
        dirPath = w.doc.path.fullName + '../../' + dirName;
      }
      if ( mainWin.dirNearFile == true ) {
        dirPath = w.doc.path.fullName + '../' + dirName;
      }
      /*  if (!File(dirPath).exists) {
       dir = new Folder(dirPath);
       dir.create();
       }*/
      dir = new Folder ( dirPath );
      dir.create ();
    }
    return dir;
  }

  function setSuffix ( o, w, j ) {
    var suffix = '';
    switch ( true ) {
      case o.laysSuff.value:
        (mainWin.appVer < 16)
          ? suffix = '_' + o.laysList.selection[ 0 ].text
          : suffix = '_' + o.laysList.selection[ o.laysList.selection.length - 1 ].text;
        break;
      case o.ordinalNumSuff.value:
        suffix = '_0' + mainWin.count;
        mainWin.count++;
        break;
      case o.randNumSuff.value:
        suffix = '_@' + mainWin.randStrArr[ j ];
        break;
      case o.selfSuff.value:
        suffix = o.selfSuffTxt.text;
        break;
      default:
        break;
    }
    return spaceOnDash ( suffix );
  }

  function getFullName ( suffix ) {
    var doc = activeDocument;
    var fullPath, fileName;
// имя файла без расширения
    (doc.path.exists) ? fileName = doc.name.slice ( 0, -(getFileExt ().length) ) : fileName = doc.name;

    if ( mainWin.customDir ) {
      fullPath = mainWin.customDir.fullName + '/' + spaceOnDash ( fileName ) + spaceOnDash ( suffix ) + '.jpg';
    } else {
      if ( mainWin.dirNearFile == false ) {
        fullPath =
          doc.path.fullName + '../../' + 'jpg' + '/' + spaceOnDash ( fileName ) + spaceOnDash ( suffix ) + '.jpg';
      } else if ( mainWin.dirNearFile == true ) {
        fullPath = doc.path.fullName + '/' + 'jpg' + '/' + spaceOnDash ( fileName ) + spaceOnDash ( suffix ) + '.jpg';
      }
    }
    return fullPath;
  }

  /**============================>>
   * THE COMMON LIBRARY *
   ==============================*/

  function showObjProps ( o ) {
    var str = '';
    for ( var key in o ) {
      var val = o[ key ];
      str += key + ': ' + val + '\n';
    }
    return str;
  }

  function makeRandStrArr ( len ) {
    var arr = [];
    for ( var i = 0; i < len; i++ ) {
      var str = ("@" + (+new Date ()) * Math.random () * 10000).slice ( -7, -1 );
      arr.push ( str );
    }
    return arr;
  }

  function spaceOnDash ( str ) {
    str = '' + str;
    var newStr = '';
    for ( var l = 0; l < str.length; l++ ) {
      (str.charAt ( l ) == ' ') ? newStr += '-' : newStr += str[ l ];
    }
    return newStr;
  }

  function getLaysNames ( doc, lays ) {
    doc = doc || activeDocument;
    lays = lays || doc.layers;
    var arrNames = [];
    for ( var i = 0; i < lays.length; i++ ) {
      arrNames.push ( lays[ i ].name );
    }
    return arrNames;
  }

  function getAllLays ( doc ) {
    doc = doc || activeDocument;
    var lays = doc.layers;
    return lays;
  }

  function getFileExt () {
    var doc = activeDocument;
    return (doc.name.lastIndexOf ( '.' ) == -1) ? -1 : doc.name.slice ( doc.name.lastIndexOf ( '.' ) );
  }

  /**======================================>>
   * THE DIFFERENT WINDOWS LIBRARY *
   =======================================*/

  function promptNumb ( opts ) {
    opts = opts || {};
    var dialTitle = opts.dialTitle || 'Number of JPEGs';
    var statText = opts.statText || 'Укажите количество jpeg-файлов';
    var editText = opts.editText || 3;
    var editTextChars = opts.editTextCharacters || 3;
    var maxVal = opts.maxVal || 5;
    var minVal = opts.minVal || 1;

    var w = new Window ( 'dialog', dialTitle, undefined, { closeButton: false } );
    w.statText = w.add ( 'statictext', undefined, statText );
    w.editText = w.add ( 'edittext {justify:"center"}' );
    w.editText.text = editText;
    w.editText.characters = editTextChars;
    w.editText.active = true;
    w.buttonsGroup = w.add ( 'group' );
    w.buttonsGroup.orientation = 'row';
    w.okButt = w.buttonsGroup.add ( 'button', undefined, 'Ok' );
    w.canselButt = w.buttonsGroup.add ( 'button', undefined, 'Cancel' );
    // the event hendlers
    w.editText.addEventListener ( 'changing', function () {
      if ( w.editText.text > maxVal ) {
        w.editText.text = maxVal;
        w.editText.active = false;
        w.editText.active = true;
      } else if ( w.editText.text < minVal ) {
        w.editText.text = minVal;
        w.editText.active = false;
        w.editText.active = true;
      }
    } )
    w.editText.addEventListener ( "keydown", function ( k ) {
      handle_key ( k, this );
    } );
    w.canselButt.addEventListener ( 'click', function () {
      w.editText.text = 0;
    } )
    w.canselButt.onClick = function () {
      w.editText.text = 0;
      w.close ();
      return 0;
    }
    w.addEventListener ( 'keydown', function ( k ) {
      if ( k.keyName == 'Enter' ) {
        w.close ();
        return 0;
      } else if ( k.keyName == 'Escape' ) {
        w.editText.text = 0;
        w.close ();
        return 0;
      }
    } )
    w.show ();
    return +w.editText.text;
    // the hendler functions
    function handle_key ( key, control ) {
      var step;
      key.shiftKey ? step = 10 : step = 1;

      switch ( key.keyName ) {
        case "Up":
          control.text = String ( Number ( control.text ) + step );
          if ( control.text > maxVal ) {
            control.text = maxVal;
            w.editText.active = false;
            w.editText.active = true;
          }
          break;
        case "Down":
          control.text = String ( Number ( control.text ) - step );
          if ( control.text < minVal ) {
            control.text = minVal;
            w.editText.active = false;
            w.editText.active = true;
          }
      }
    }
  }

  function alert_scroll ( input, title ) {
    title = title || 'Scrollable alert';
// if input is an array, convert it to a string
    if ( input instanceof Array ) {
      input = input.join ( "\r" );
    }
    var w = new Window ( "dialog", title );
    var list = w.add ( "edittext", undefined, input, { multiline: true, scrolling: true } );
// the list should not be bigger than the maximum possible height of the window
    list.maximumSize.height = w.maximumSize.height - 100;
    list.minimumSize.width = 600;
    w.add ( "button", undefined, "Уходим", { name: "ok" } );
    /*w.onShow = function() {
     w.location.x += mainWindow.location.x;
     }*/
    w.show ();
  }

//=================================<<
}